import StartupScript

__doc__ = """Zope product providing startup scripts."""
__version__ = '0.9.0'

def initialize(context):
  """Initialise the product."""

  context.registerClass(
   StartupScript.StartupScript,
   permission='Add Python Scripts',
   constructors=(StartupScript.manage_addPythonScriptForm,
    StartupScript.manage_addPythonScript),
   icon='www/pystartupscript.gif'
  )

  # What follows is the tricky bit. If we were to try and
  # run any scripts right now, we face the problem that not
  # all products may yet have been initialised. Thus we need
  # to defer running the scripts to a later point, although
  # at a point whereby web serving hasn't commenced. By
  # registering with asyncore to be notified when the main
  # loop has be entered we can achieve this.

  import ThreadedAsync.LoopCallback
  ThreadedAsync.LoopCallback.register_loop_callback(
   StartupScript.startup_PythonScripts)
